﻿local GarrisonDone = ...

if (not GarrisonDone_Varsm) then GarrisonDone_Varsm = {} end

if (not GarrisonDoneFrame) then GarrisonDoneFrame = GarrisonDoneFrame end
    
local DEBUG = false;

local playerName = UnitName("player");

C_Timer.After(20, function() GarrisonDone_minimap(self, mgdldb) end)
                        
            -- LDB LAUNCHER and LDB MINIMAP ICON --
local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
local GarrisonDone_Vars = _G.GarrisonDone_Vars
local MGDTip = LibStub('LibQTip-1.0')
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1")
local icon = LibStub("LibDBIcon-1.0")

        
            -- LDB --    
local mgdldb = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("GarrisonDone", {
            type = "data source",
	        text = "My Garrison",
            label = "My Garrison",
            tocname = "GarrisonDone",
            icon = "Interface\\AddOns\\GarrisonDone\\images\\MGDL.tga",
                -- Set Qtip functions and Create tooltip --
            OnEnter = function(frame)
		        mgdldb_tip = MGDTip:Acquire('GarrisonDone', 5, "LEFT", "CENTER")
		        mgdldb_tip:Hide() -- Hide the tt we don't need it yet --
		        mgdldb_tip:Clear() -- Clear the tt if we pulled it from pool --
		        mgdldb_tip:SetScale(1) -- Set the tt Scale we need (this adjusts fonts to) --
                mgdldb_tip:SetFrameStrata("DIALOG")
                mgdldb_tip:SetBackdropColor(0, 0, 0, 1.0)
                mgdldb_tip:SetAlpha(1.0)
                -- Call the Data --
		        MGD_Tooltip()
                -- Anchor tooltip to LDB --
		        mgdldb_tip:SmartAnchorTo(frame)
                 -- Delay Hideing Frame when mouse moves away --
                mgdldb_tip:SetAutoHideDelay(1.50)
                -- Enable Mouse Over so Window Stays Open until Mouse Leaves --
                mgdldb_tip:EnableMouse(true)   
                -- Set Max Height and Scroll Bar --
                mgdldb_tip:UpdateScrolling(370)
                -- Show Tooltip --
		        mgdldb_tip:Show()
	        end,
   
            OnClick = function(self, button, ...)
            if (button == "LeftButton") then
		    if GarrisonDoneFrame:IsShown() then
                GarrisonDoneFrame:Hide()
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneEditFrame:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                MGD_IntButton:Hide();
                MGD_LdbButton:Hide();
                GarrisonDoneLdbEditFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
            else
                PanelTemplates_SetTab(GarrisonDoneFrame, 1);
                GarrisonDoneFrame:Show()
                GarrisonDoneEditFrame:Show();
                MGD_FollowersButton:Show();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                MGD_IntButton:Hide();
                MGD_LdbButton:Hide();
                GarrisonDoneLdbEditFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
                end
       	    elseif (button == "RightButton") then
                if GarrisonDoneLdbEditFrame:IsShown() then
                PanelTemplates_SetTab(GarrisonDoneFrame, 1);
			    GarrisonDoneEditFrame:Show();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                MGD_IntButton:Hide();
                MGD_LdbButton:Hide();
                GarrisonDoneLdbEditFrame:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
            else
                GarrisonDoneFrame:Show()
                GarrisonDoneLdbEditFrame:Show();
                MGD_IntButton:Show();
                MGD_LdbButton:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneEditFrame:Hide();
                MGD_FollowersButton:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
                GarrisonDone_OptionsOnShow(self);
            
            end
        end
    end,
    
            
    
		    
    })
     
                
                
                -- START LDB Dispaly Tooltip --

local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
local GarrisonDone_Varsm = _G.GarrisonDone_Varsm



    
        -- Update LDB Data --        
function MGD_Tooltip()
            local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
            local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
            local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
            local GarrisonDone_Vars = _G.GarrisonDone_Vars

        -- START GARRISON DATA --
                            
            -- Assign Local Variables straight from Blizz frame --
            local missionsldb = C_Garrison.GetInProgressMissions()
    
            -- Max Followers --
            local maxFollowersldb = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local maxShipsldb = C_Garrison.GetFollowerSoftCap(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Active Followers --
            local numActiveFollowersldb = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local numActiveShipsldb = C_Garrison.GetNumActiveFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Missions Available --
            local AvailableItemsldb = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local shipMissionsldb = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
            -- Missions Complete --
            local completeMissionsldb = C_Garrison.GetCompleteMissions(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local shipCompleteldb = C_Garrison.GetCompleteMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
            
            -- Ship Missions in Progress --
            local ldbsitems = C_Garrison.GetInProgressMissions(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
            local ldbshipmis = 0;
            for i = 1, #ldbsitems do
            if (ldbsitems[i].followerTypeID == 2) then
                        ldbshipmis = ldbshipmis + 1
                end
            end        
            local ldbmips = ldbshipmis - #shipCompleteldb
            
            -- Missions in Progress --
            local ldbitems = C_Garrison.GetLandingPageItems(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local ldbmip = (#ldbitems - ldbshipmis) - #completeMissionsldb;
            
            -- Find all our Followers/Ships and Set Status --
            local ldbfollowers = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_GARRISON_6_0);
            local ldbships = C_Garrison.GetFollowers(LE_FOLLOWER_TYPE_SHIPYARD_6_2);
    
                -- Followers working --
            local ldbwork = 0;
            for i = 1, #ldbfollowers do
	        if ( ldbfollowers[i].status == GARRISON_FOLLOWER_WORKING) then
		        ldbwork = ldbwork + 1;
                end
            end
                -- Followers on Missions --
            local ldbgfm = 0;
            for i = 1, #ldbfollowers do
	            if ( ldbfollowers[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		            ldbgfm = ldbgfm + 1;
                end
            end
                -- Ships on Missions --
            local ldbatSea = 0;
            for i = 1, #ldbships do
	            if ( ldbships[i].status == GARRISON_FOLLOWER_ON_MISSION) then
		            ldbatSea = ldbatSea + 1;
                end
            end
            
            local ldbfBusy = ldbgfm + ldbwork;
            local ldbavailable = numActiveFollowersldb - ldbfBusy;
            local ldbharbour = numActiveShipsldb - ldbatSea;
            
                -- Garrison Resources --
            local _, currentAmount, _, _, _, _, _ = GetCurrencyInfo(824);
            local _, currAmount, _, _, _, _, _ = GetCurrencyInfo(1101);
    
                -- Mining Nodes --
            local ore = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.miningLeft > 0 then
		        ore = format("%s", GarrisonDone_Varsc.miningLeft)
                tonumber(ore)
		        end
            end
            local ores = 0;
            if GarrisonDone_Varsc.hasMine == true then
		        if GarrisonDone_Varsc.maxMining > 0 then
		        ores = format("%s", GarrisonDone_Varsc.maxMining)
                tonumber(ores)
		        end
	        end 
                -- Herb Nodes --
            local herb = 0;
            if GarrisonDone_Varsc.hasGarden == true then
    	        if GarrisonDone_Varsc.herbingLeft > 0 then
		        herb = format("%s", GarrisonDone_Varsc.herbingLeft)
                tonumber(herb)
		        end
	        end 
            local herbs = 0;
            if GarrisonDone_Varsc.hasGarden == true then
		        if GarrisonDone_Varsc.maxHerbing > 0 then
		        herbs = format("%s", GarrisonDone_Varsc.maxHerbing)
                tonumber(herbs)
                
                            end
                        end
		                        
            local Icon = [[|TInterface\BUTTONS\UI-GuildButton-PublicNote-Up:14:14|t]] -- False Error in Designer --

                
                -- PRINT GARRISON DATA --
                if GarrisonDone_Varsc.ldbgar ~= true then
                mgdldb_tip:SetColumnLayout(4, "LEFT")
                lineNum = mgdldb_tip:AddHeader()
                mgdldb_tip:SetCell(lineNum, 1, ""..playerName.."'s Garrison", "CENTER", 4);
                mgdldb_tip:SetCellScript(lineNum, 1, "OnEnter", mgdldb_Update )
                mgdldb_tip:AddLine("")
                mgdldb_tip:AddSeparator(2)
                    -- Missions in Progress --
                    if ldbmip ~= 0 then
                local y, x = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(y, 1, Icon)
                mgdldb_tip:SetCellScript(y, 1, "OnEnter", missionldb_OnEnter )
		        mgdldb_tip:SetCell(y, 2, ("|cfffeef02Missions in Progress"));
                mgdldb_tip:SetCell(y, 3, ("|cff007fff= |cffffffff"..ldbmip..""))
                    elseif ldbmip == 0 then
                local y, x = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(y, 1, Icon)
                mgdldb_tip:SetCellScript(y, 1, "OnEnter", missionldb_OnEnter ) 
                mgdldb_tip:SetCell(y, 2, ("|cffffffffMissions in Progress"));
                mgdldb_tip:SetCell(y, 3, ("|cff007fff = |cffff0000"..ldbmip..""))
                    end 
                mgdldb_tip:AddSeparator(1, g)
                    -- Complete Missions --
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 2, ("|cfffeef02Missions Complete"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cff00aa00"..#completeMissionsldb..""))
                    -- Missions Available --
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 2, ("|cfffeef02Missions Available"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff =|r |cffFFFC00"..#AvailableItemsldb..""))
                mgdldb_tip:AddSeparator(1, g)  
                    -- Followers --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cffFF8000Total |cff62fb71Followers"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFFFC00"..numActiveFollowersldb.."|cff007fff/|cffFF8000"..maxFollowersldb..""))
                    -- Followers on Mission --
                    if ldbgfm ~= 0 then
                    line = mgdldb_tip:AddLine()
	            mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers on Mission"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFF8000"..ldbgfm..""))
                    elseif ldbgfm == 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers on Mission"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffff0000"..ldbgfm..""))
                    end
                    -- Followers Available --
                    if ldbavailable > 0 then
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers Available"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFFFC00"..ldbavailable..""))
                    elseif ldbavailable == 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers Available"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFF8000"..ldbavailable..""))
                    elseif ldbavailable > 25 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers Available"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffff0000"..ldbavailable..""))
                    end
                    -- Followers Working --
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 2, ("|cff62fb71Followers|r Working"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFFFC00"..ldbwork..""))
                
                mgdldb_tip:AddSeparator(1, g)
                    -- Building Data --
                    local r, s = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(r, 1, Icon)
                mgdldb_tip:SetCellScript(r, 1, "OnEnter", followerldb_OnEnter )
		        mgdldb_tip:SetCell(r, 2, ("|cff62fb71Building Information"));
                -- mgdldb_tip:SetCell(r, 3, ())
                
                mgdldb_tip:AddSeparator(1, g)
                    -- Ships Missions in Progress --
                    if GarrisonDone_Varsc.hasShipyard ~= true then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cfffeef02No Harbour Detected."));   
                    elseif ldbmips ~= 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cfffeef02Ships in Progress"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |r|cffffffff"..ldbmips..""))
                    elseif ldbmips == 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cffffffffShips in Progress"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cff00aa00"..ldbmips..""))
                    end
                    -- Ships Missions Complete --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cfffeef02Ships Complete"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |r"..#shipCompleteldb..""))
                    -- Ships Mission Available --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cfffeef02Ship Missions Avail"));
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFFFC00"..#shipMissionsldb..""))
                mgdldb_tip:AddSeparator(1, g)
                    -- Number of Ships --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cffFF8000Total |cff53aafcShips"))
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |r|cff00aa00"..numActiveShipsldb.."/|cffFF8000"..maxShipsldb..""))   
                    -- Ships out on Mission --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cff53aafcShips at Sea"))
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |cffFFFC00"..ldbatSea..""))
                    -- Ships in Shipyard --
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 2, ("|cff53aafcShips in Dock"))
                mgdldb_tip:SetCell(line, 3, ("|cff007fff = |r|cff00aa00"..ldbharbour..""))
                mgdldb_tip:AddSeparator(1, g)
                
                    -- Garrison Resources and Oil --
		        mgdldb_tip:AddLine(nil, "|cfffeef02Resources|cff007fff = |r"..currentAmount.."")
                mgdldb_tip:AddLine(nil, "|cffFF8000Oil|cff007fff = |r"..currAmount.."")
                mgdldb_tip:AddSeparator(1, g)  
                
                    -- Mining Nodes --    -- Herb Nodes --                    
                    if ore ~= 0 and herb ~= 0 then
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 1, ("|cfffeef02Mine:|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."|cfffeef02  Herbs:|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs..""), "CENTER", 4);                    
                    elseif ore == 0 and herb ~= 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 1, ("|cfffeef02Mine:|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."|cfffeef02  Herbs:|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs..""), "CENTER", 4);
                    -- Herb Nodes --                    
                    elseif herb == 0 and ore ~= 0 then
                    line = mgdldb_tip:AddLine()
		        mgdldb_tip:SetCell(line, 1, ("|cfffeef02Mine:|cff007fff = |cffff0000"..ore.."|cff007fff/|cff00aa00"..ores.."|cfffeef02  Herbs:|cff007fff = |cffff0000"..herb.."|cff007fff/|cff00aa00"..herbs..""), "CENTER", 4);                    
                    elseif herb == 0 and ore == 0 then
                    line = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(line, 1, ("|cfffeef02Mine:|cff007fff = |r"..ore.."|cff007fff/|cff00aa00"..ores.."|cfffeef02  Herbs:|cff007fff = |r"..herb.."|cff007fff/|cff00aa00"..herbs..""), "CENTER", 4);  
                    end 
                mgdldb_tip:AddSeparator(2)
                    -- LDB Options --
                local y, x = mgdldb_tip:AddLine()
                mgdldb_tip:SetCell(y, 2, ""..Icon.."|cff00aa00LDB Options")
                mgdldb_tip:SetCellScript(y, 2, "OnMouseDown", 
                function() GarrisonDoneFrame:Show()
                GarrisonDoneLdbEditFrame:Show();
                MGD_IntButton:Show();
                MGD_LdbButton:Hide();
                GarrisonDoneOptEditFrame:Hide();
                GarrisonDoneEditFrame:Hide();
                MGD_FollowersButton:Hide();
                GarrisonDoneBuildFrame:Hide();
                GarrisonDoneBuildScrollFrame:Hide();
                GarrisonDoneAltsFrame:Hide();
                GarrisonDoneAltsScrollFrame:Hide();
                GarrisonDoneFollowersFrame:Hide();
                GarrisonDoneFollowersScrollFrame:Hide();
                GarrisonDone_OptionsOnShow(self);  
                end)
                mgdldb_tip:SetCell(y, 3, ""..Icon.."|cff00aa00Blizz")
                mgdldb_tip:SetCellScript(y, 3, "OnMouseDown", function() InterfaceOptionsFrame_OpenToCategory("LDB Options"); InterfaceOptionsFrame_OpenToCategory("LDB Options"); end)
                mgdldb_tip:AddSeparator(2)
                local line = mgdldb_tip:AddLine()
                mgdldb_tip:AddLine("")
                          
    end
end
            -- End Garrison Data --
            
            
            -- START MISSION DATA -- 

function missionldb_OnEnter(frame)     
                    -- Gather Mission Data --
            local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
            local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
            local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
            local GarrisonDone_Vars = _G.GarrisonDone_Vars
            
                                -- Add Tooltip --    
                                local Mission_tip = MGDTip:Acquire("mission")
                                Mission_tip:Hide() 
		                        Mission_tip:Clear() 
                                Mission_tip:SetBackdropColor(0.0, 0.0, 0.0, 1.0)
		                        Mission_tip:SetScale(1) 
                                Mission_tip:SetFrameStrata("TOOLTIP")
                                Mission_tip:SetAlpha(1.0)
                                Mission_tip:SmartAnchorTo(frame)
                                Mission_tip:UpdateScrolling(350)
                                Mission_tip:SetAutoHideDelay(0.50, frame)
                                Mission_tip:EnableMouse(true)            
            
                                if GarrisonDone_Varsc.ldbmiss ~= true then
                                Mission_tip:SetColumnLayout(4, "LEFT")
                                lineNum = Mission_tip:AddHeader()
                                Mission_tip:SetCell(lineNum, 1, "All Characters Missions", "CENTER", 4);
                                Mission_tip:AddLine("")
                                Mission_tip:AddSeparator(2) 
                
                                line = Mission_tip:AddLine()
                                Mission_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                                Mission_tip:SetCell(line, 1, ("|cffFF8000Name"))
                                Mission_tip:SetCell(line, 2, ("|cffFF8000Mission"))
                                Mission_tip:SetCell(line, 3, ("|cffFF8000Type"))
                                Mission_tip:SetCell(line, 4, ("|cffFF8000Time"))
                                Mission_tip:AddSeparator(2)
                                Mission_tip:AddLine("")
                                
			local i = 0
			local b = 0 
				if GarrisonDone_Vars then
					for realm, v1 in pairs(GarrisonDone_Vars) do
						for character, v2 in pairs(v1) do
							for index, data in pairs(v2) do
								i = i + 1
									local name = data.name
									local t = data.endTime - time()
									local missionID = data.missionID
									
                                    local color = "|cffE6CC80"
                                        -- Set Class Colors --
                                    if data.class == "Death Knight" then color = "|cffC41F3B"
                                    elseif data.class == "Druid" then color = "|cffFF7D0A"
                                    elseif data.class == "Hunter" then color = "|cffABD473"
                                    elseif data.class == "Mage" then color = "|cff69CCF0"
                                    elseif data.class == "Monk" then color = "|cff00FF96"
                                    elseif data.class == "Paladin" then color = "|cffF58CBA"
                                    elseif data.class == "Priest" then color = "|cffFFFFFF"
                                    elseif data.class == "Rogue" then color = "|cffFFF569"
                                    elseif data.class == "Shaman" then color = "|cff0070DE"
                                    elseif data.class == "Warlock" then color = "|cff9482C9"
                                    elseif data.class == "Warrior" then color = "|cffC79C6E"
                                    end
                                    
                                        -- Change Type Colour for Ship and Rare Missions --
                                    local colo = "|cfffeef02"
                                    if data.isRare == true then colo = "|cff0070FF" 
                                    elseif data.followerTypeID == 2 then colo = "|cffFF8000" end
                                 
                                   
                                    
                                    -- Print Mission Time --
                                if t > 60 then
                                if GarrisonDone_Varsc.ldbcomp ~= true then
                                line = Mission_tip:AddLine()
                                Mission_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                                Mission_tip:SetCell(line, 1, (string.format(color..character.."-"..realm..":")))
                                Mission_tip:SetCell(line, 2, ("|cffE6CC80"..name..""))
                                Mission_tip:SetCell(line, 3, (string.format(colo..data.type.."")))
                                Mission_tip:SetCell(line, 4, (string.format("%s %02d:%02d", "|cff00FAF6", floor(t/3600), floor(mod(t,3600)/60))))
                                Mission_tip:AddSeparator(2, 0.0, 0.0, 0.0, 1.0)
                                end
                                else
                                if t < 60 then  -- Print Mission Ready --
                                line = Mission_tip:AddLine()
                                Mission_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                                Mission_tip:SetCell(line, 1, (string.format(color..character.."-"..realm..":")))
                                Mission_tip:SetCell(line, 2, ("|cffE6CC80"..name..""))
                                Mission_tip:SetCell(line, 3, (string.format(colo..data.type.."")))
                                Mission_tip:SetCell(line, 4, ("|cff1EFF0CReady"))
		                        Mission_tip:AddSeparator(2, 0.0, 0.0, 0.0, 1.0)   
                                    end
                                end
                            end
                            Mission_tip:AddSeparator(2)
                            Mission_tip:UpdateScrolling(350)
                            Mission_tip:Show();                    
                end
            end
        end
    end
end

            -- End Mission Data --
            
            
            -- START BUILDINGS AND FOLLOWER ASSIGNED DATA --
            
function followerldb_OnEnter(frame)     
                    -- Gather Mission Data --
            local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
            local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
            local GarrisonDone_Varsf = _G.GarrisonDone_Varsf
            local GarrisonDone_Vars = _G.GarrisonDone_Vars
            
                        -- Add Tooltip --    
                    local Follower_tip = MGDTip:Acquire("follower")
                    Follower_tip:Hide() 
		            Follower_tip:Clear() 
                    Follower_tip:SetBackdropColor(0, 0, 0)
		            Follower_tip:SetScale(1) 
                    Follower_tip:SetFrameStrata("TOOLTIP")
                    Follower_tip:SetAlpha(1.0)
                    -- Follower_tip:SetHeight(350)
                    Follower_tip:SmartAnchorTo(frame, "ANCHOR_LEFT")
                    Follower_tip:UpdateScrolling(330)
                    Follower_tip:SetAutoHideDelay(0.50, frame)
                    Follower_tip:EnableMouse(true)
            
                    if GarrisonDone_Varsc.ldbbui ~= true then
                    Follower_tip:SetColumnLayout(6, "LEFT", "LEFT", "LEFT", "CENTER", "RIGHT", "RIGHT")
                    lineNum = Follower_tip:AddHeader()
                    Follower_tip:SetCell(lineNum, 1, "All Buildings Data", "CENTER", 6);
                    Follower_tip:AddLine("")
                    Follower_tip:AddSeparator(2) 
                
                    line = Follower_tip:AddLine()
                    Follower_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                    Follower_tip:SetCell(line, 1, ("|cffFF8000Name"))
                    Follower_tip:SetCell(line, 2, ("|cffFF8000Building"))
                    Follower_tip:SetCell(line, 3, ("|cffFF8000Follower"))
                    Follower_tip:SetCell(line, 4, ("|cffFF8000Production"))
                    Follower_tip:SetCell(line, 5, ("|cffFF8000Next"))
                    Follower_tip:SetCell(line, 6, ("|cff000000Total"))
                    Follower_tip:AddSeparator(2)
                    Follower_tip:AddLine("")
            
            local followers = GarrisonDone_Varsm.mgdtip_sections.followers
           

                -- Add data --
                if GarrisonDone_Varsf then
					for realm, v1 in pairs(GarrisonDone_Varsf) do
						for character, v2 in pairs(v1) do
						    for index, data in pairs(v2) do
                            table.sort (data,
			                function ( char1, char2 )
				            if char1["realm"] == char2["realm"] then
					            return char1[UnitName("player")] > char2["character"];
				            else                                
					            return char1[UnitName("player")] > char2["character"];
				                end
			                end);
                            
                            if data.class == "Death Knight" then color = "|cffC41F3B"
                            elseif data.class == "Druid" then color = "|cffFF7D0A"
                            elseif data.class == "Hunter" then color = "|cffABD473"
                            elseif data.class == "Mage" then color = "|cff69CCF0"
                            elseif data.class == "Monk" then color = "|cff00FF96"
                            elseif data.class == "Paladin" then color = "|cffF58CBA"
                            elseif data.class == "Priest" then color = "|cffFFFFFF"
                            elseif data.class == "Rogue" then color = "|cffFFF569"
                            elseif data.class == "Shaman" then color = "|cff0070DE"
                            elseif data.class == "Warlock" then color = "|cff9482C9"
                            elseif data.class == "Warrior" then color = "|cffC79C6E"
                            end
                            
                            
                                        -- Give Ready and Total a number in case there are none in progress --
                                    if data.ready == nil then data.ready = 0 end
                                    if data.total == nil then data.total = 0 end
                                    if data.capacity == nil then data.capacity = 0 end
                                        -- Count down In progress --
                                    if data.inprog == 0 then data.inprog = data.total - data.ready end         
                                        -- adjust time left if = 0 --
                                    if data.timeLeft == nil then data.timeLeft = "None" end
                                        -- Give Creation and time to seconds a number in case it = nil --
                                    if data.creationTime == nil then data.creationTime = 0 end
                                    if data.toSeconds == nil then data.toSeconds = 0 end
                                        --  Set timer to count down till next shipment, should reset till total = 0 --
                                    if data.duration == nil then data.duration = 0 end
                                        -- set Gone Fishing --
                                    if data.name == nil then data.name = "Gone Fishing" end
                                    if data.name == "Gone Fishing" then
                                    if data.idName == "Trading Post" then data.name = "|cffFFC670Joseph|r" end
                                    if data.idName == "Lunarfall Shipyard" then data.name = "|cffFFC670Y.Seastrike|r" end
                                    if data.idName == "Dwarven Bunker" then data.name = "|cffFFC670K. Stoneforge|r" end
                                    if data.idName == "Gnomish Gearworks" then data.name = "|cffFFC670Zee|r" end
                                    end
                                        
                                        
                                        -- start data for timers --
                                    local t = 0
                                    local count = 0
                                    local te = data.toSeconds -- time till 1st shipment ready, needs to reset after each shipment --
                                    local ip = data.inprog
                                    
                                    if te <= 0 and ip > 0 then
                                        data.toSeconds = 14400
                                    elseif data.inprog <= 0 and ip <= 0 then
                                        data.toSeconds = 0
                                    end
                                    
                                    local ready = data.ready
                                    local inprog = data.inprog
                                    local count = 0
                                    if data.character ~= UnitName("player") then
                                    te = data.lastUpdate + data.toSeconds
                                    if te <= time() and ip > 0 then
                                    count = count + 1
                                    ready = ready + count
                                    inprog = inprog - count
                                    te = (data.lastUpdate + data.toSeconds) + (count * 14400)
                                        end
                                    end
                                    
                                    if data.character == UnitName("player") then
                                    t = (time() + te) - time()
                                    elseif data.character ~= UnitName("player") then
                                    t = te - time()
                                    end
                                    if data.character ~= UnitName("player") and t <= 0 then
                                    t = 0
                                    end
                                    
                            
                    if data.name ~= "Gone Fishing" then
                    line = Follower_tip:AddLine()
                    Follower_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                    Follower_tip:SetCell(line, 1, (string.format(color..character.." - "..data.realm.."")))
                    Follower_tip:SetCell(line, 2, ("|cffE6CC80"..data.idName..""))
                    Follower_tip:SetCell(line, 3, ("|cfffeef02"..data.name..""))
                    if data.idName == "Barracks" then
                    Follower_tip:SetCell(line, 4, ("|cffE6CC80BodyGuard"))
                    elseif data.idName == "Fishing Shack" then 
                    Follower_tip:SetCell(line, 4, ("|cffE6CC80Ron Ashton"))
                    elseif data.idName ~= "Barracks" and data.idName ~= "Fishing Shack" then
                    Follower_tip:SetCell(line, 4, ("|cff1eff00"..ready.."|cffffffff - |cfffeef02"..inprog.."|cffffffff - |cffe6cc80"..data.capacity.."" ))
                    end
                    if data.idName == "Barracks" and data.name ~= "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00On Duty"))
                    elseif data.idName == "Barracks" and data.name == "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff7A4919Off Duty"))
                    elseif data.idName == "Fishing Shack" and data.name ~= "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00On Duty"))
                    elseif data.idName == "Fishing Shack" and data.name == "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00Lunch"))
                    elseif data.idName ~= "Barracks" and data.idName ~= "Fishing Shack" then
                    Follower_tip:SetCell(line, 5, (string.format("%s %02d:%02d", "|cff00FAF6", floor(t/3600), floor(mod(t,3600)/60))))
                    end
                    elseif data.name == "Gone Fishing" then
                    line = Follower_tip:AddLine()
                    Follower_tip:SetLineColor(line, 0.0, 0.0, 0.0, 1.0)
                    Follower_tip:SetCell(line, 1, (string.format(color..character.." - "..data.realm.."")))
                    Follower_tip:SetCell(line, 2, ("|cffE6CC80"..data.idName..""))
                    Follower_tip:SetCell(line, 3, ("|cff62fb71"..data.name..""))
                    if data.idName == "Barracks" then
                    Follower_tip:SetCell(line, 4, ("|cffE6CC80BodyGuard"))
                    elseif data.idName == "Fishing Shack" then
                    Follower_tip:SetCell(line, 4, ("|cffE6CC80Ron Ashton"))
                    elseif data.idName ~= "Barracks" and data.idName ~= "Fishing Shack" then
                    Follower_tip:SetCell(line, 4, ("|cff1eff00"..ready.."|cffffffff - |cfffeef02"..inprog.."|cffffffff - |cffe6cc80"..data.capacity.."" ))
                    end
                    if data.idName == "Barracks" and data.name ~= "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00On Duty"))
                    elseif data.idName == "Barracks" and data.name == "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff7A4919Off Duty"))
                    elseif data.idName == "Fishing Shack" and data.name ~= "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00On Duty"))
                    elseif data.idName == "Fishing Shack" and data.name == "Gone Fishing" then
                    Follower_tip:SetCell(line, 5, ("|cff1eff00Lunch"))
                    elseif data.idName ~= "Barracks" and data.idName ~= "Fishing Shack" then
                    Follower_tip:SetCell(line, 5, (string.format("%s %02d:%02d", "|cff00FAF6", floor(t/3600), floor(mod(t,3600)/60))))
                                end  
                            end
                        end
                    Follower_tip:AddSeparator()
                end
                Follower_tip:AddSeparator(1, b, 0.5)
                line = Follower_tip:AddLine()
                Follower_tip:SetCell(line, 1, "Hint: |cff1eff00Green|r = Ready, |cfffeef02Yellow|r = In Progress, |cffe6cc80Beige|r = Cap", "CENTER", 5);
                Follower_tip:UpdateScrolling(330)
                Follower_tip:Show();
            end
        end
    end
end   
 
            -- End Followers Assigned Data -- -- End Building Shipments Data --
            



        -- OTHER Tooltips we need --

   


    -- Update LDB Data --
function mgdldb_Update()
--    if mgdldb_frame:IsShown() == true then
	    GarrisonDone_UpdateData(data)
        GarrisonDone_UpdateShipData(data)
        GarrisonDone_UpdateFollowerData(data)
        GarrisonDone_Update(self)
      DEFAULT_CHAT_FRAME:AddMessage("Sir We have Updated The LDB List") -- debug
--    end
end


                -- END LDB Dispaly Tooltip --
                
                
                

                -- LDB Minimap Icon --
 
LibStub("LibDBIcon-1.0"):Register("GarrisonDone", mgdldb, GarrisonDone_Varsm.minimap)
 
   

function GarrisonDone_minimap(self, mgdldb)
    local GarrisonDone_Varsm = _G.GarrisonDone_Varsm
    local GarrisonDone_Varsc = _G.GarrisonDone_Varsc
	if GarrisonDone_Varsm.minimap.hide == true then
		icon:Hide("GarrisonDone")
	else 
		icon:Show("GarrisonDone")
	end
end


        -- END LDB Minimap Icon --     
        